module pjfry95pj

  use precision_golem, only: ki
  use pjfry95pg
  use form_factor_type
  implicit none

  contains


  function pja10(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja10
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja10=temp
  end function pja10

  function pja11(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja11
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja11=temp
  end function pja11

  function pja20(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja20
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja20=temp
  end function pja20

  function pja21(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja21
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja21=temp
  end function pja21

  function pja22(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pja22
    complex(ki), dimension(3) :: temp
    temp(1)=pga2(i, j, b_pin, 2)
    temp(2)=pga2(i, j, b_pin, 1)
    temp(3)=pga2(i, j, b_pin, 0)
    pja22=temp
  end function pja22

  function pjb22(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjb22
    complex(ki), dimension(3) :: temp
    temp(1)=pgb2(b_pin, 2)
    temp(2)=pgb2(b_pin, 1)
    temp(3)=pgb2(b_pin, 0)
    pjb22=temp
  end function pjb22

  function pja30(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja30
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja30=temp
  end function pja30

  function pja31(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja31
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja31=temp
  end function pja31

  function pja32(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pja32
    complex(ki), dimension(3) :: temp
    temp(1)=pga2(i, j, b_pin, 2)
    temp(2)=pga2(i, j, b_pin, 1)
    temp(3)=pga2(i, j, b_pin, 0)
    pja32=temp
  end function pja32

  function pjb32(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjb32
    complex(ki), dimension(3) :: temp
    temp(1)=pgb2(b_pin, 2)
    temp(2)=pgb2(b_pin, 1)
    temp(3)=pgb2(b_pin, 0)
    pjb32=temp
  end function pjb32

  function pja33(i, j, k, b_pin)
    integer, intent (in) :: i, j, k, b_pin
    type(form_factor) :: pja33
    complex(ki), dimension(3) :: temp
    temp(1)=pga3(i, j, k, b_pin, 2)
    temp(2)=pga3(i, j, k, b_pin, 1)
    temp(3)=pga3(i, j, k, b_pin, 0)
    pja33=temp
  end function pja33

  function pjb33(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pjb33
    complex(ki), dimension(3) :: temp
    temp(1)=pgb3(i, b_pin, 2)
    temp(2)=pgb3(i, b_pin, 1)
    temp(3)=pgb3(i, b_pin, 0)
    pjb33=temp
  end function pjb33

  function pja40(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja40
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja40=temp
  end function pja40

  function pja41(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja41
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja41=temp
  end function pja41

  function pja42(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pja42
    complex(ki), dimension(3) :: temp
    temp(1)=pga2(i, j, b_pin, 2)
    temp(2)=pga2(i, j, b_pin, 1)
    temp(3)=pga2(i, j, b_pin, 0)
    pja42=temp
  end function pja42

  function pjb42(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjb42
    complex(ki), dimension(3) :: temp
    temp(1)=pgb2(b_pin, 2)
    temp(2)=pgb2(b_pin, 1)
    temp(3)=pgb2(b_pin, 0)
    pjb42=temp
  end function pjb42

  function pja43(i, j, k, b_pin)
    integer, intent (in) :: i, j, k, b_pin
    type(form_factor) :: pja43
    complex(ki), dimension(3) :: temp
    temp(1)=pga3(i, j, k, b_pin, 2)
    temp(2)=pga3(i, j, k, b_pin, 1)
    temp(3)=pga3(i, j, k, b_pin, 0)
    pja43=temp
  end function pja43

  function pjb43(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pjb43
    complex(ki), dimension(3) :: temp
    temp(1)=pgb3(i, b_pin, 2)
    temp(2)=pgb3(i, b_pin, 1)
    temp(3)=pgb3(i, b_pin, 0)
    pjb43=temp
  end function pjb43

  function pja44(i, j, k, l, b_pin)
    integer, intent (in) :: i, j, k, l, b_pin
    type(form_factor) :: pja44
    complex(ki), dimension(3) :: temp
    temp(1)=pga4(i, j, k, l, b_pin, 2)
    temp(2)=pga4(i, j, k, l, b_pin, 1)
    temp(3)=pga4(i, j, k, l, b_pin, 0)
    pja44=temp
  end function pja44

  function pjb44(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pjb44
    complex(ki), dimension(3) :: temp
    temp(1)=pgb4(i, j, b_pin, 2)
    temp(2)=pgb4(i, j, b_pin, 1)
    temp(3)=pgb4(i, j, b_pin, 0)
    pjb44=temp
  end function pjb44

  function pjc44(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjc44
    complex(ki), dimension(3) :: temp
    temp(1)=pgc4(b_pin, 2)
    temp(2)=pgc4(b_pin, 1)
    temp(3)=pgc4(b_pin, 0)
    pjc44=temp
  end function pjc44

  function pja50(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja50
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja50=temp
  end function pja50

  function pja51(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja51
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja51=temp
  end function pja51

  function pja52(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pja52
    complex(ki), dimension(3) :: temp
    temp(1)=pga2(i, j, b_pin, 2)
    temp(2)=pga2(i, j, b_pin, 1)
    temp(3)=pga2(i, j, b_pin, 0)
    pja52=temp
  end function pja52

  function pjb52(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjb52
    complex(ki), dimension(3) :: temp
    temp(1)=pgb2(b_pin, 2)
    temp(2)=pgb2(b_pin, 1)
    temp(3)=pgb2(b_pin, 0)
    pjb52=temp
  end function pjb52

  function pja53(i, j, k, b_pin)
    integer, intent (in) :: i, j, k, b_pin
    type(form_factor) :: pja53
    complex(ki), dimension(3) :: temp
    temp(1)=pga3(i, j, k, b_pin, 2)
    temp(2)=pga3(i, j, k, b_pin, 1)
    temp(3)=pga3(i, j, k, b_pin, 0)
    pja53=temp
  end function pja53

  function pjb53(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pjb53
    complex(ki), dimension(3) :: temp
    temp(1)=pgb3(i, b_pin, 2)
    temp(2)=pgb3(i, b_pin, 1)
    temp(3)=pgb3(i, b_pin, 0)
    pjb53=temp
  end function pjb53

  function pja54(i, j, k, l, b_pin)
    integer, intent (in) :: i, j, k, l, b_pin
    type(form_factor) :: pja54
    complex(ki), dimension(3) :: temp
    temp(1)=pga4(i, j, k, l, b_pin, 2)
    temp(2)=pga4(i, j, k, l, b_pin, 1)
    temp(3)=pga4(i, j, k, l, b_pin, 0)
    pja54=temp
  end function pja54

  function pjb54(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pjb54
    complex(ki), dimension(3) :: temp
    temp(1)=pgb4(i, j, b_pin, 2)
    temp(2)=pgb4(i, j, b_pin, 1)
    temp(3)=pgb4(i, j, b_pin, 0)
    pjb54=temp
  end function pjb54

  function pjc54(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pjc54
    complex(ki), dimension(3) :: temp
    temp(1)=pgc4(b_pin, 2)
    temp(2)=pgc4(b_pin, 1)
    temp(3)=pgc4(b_pin, 0)
    pjc54=temp
  end function pjc54

  function pja55(i, j, k, l, m, b_pin)
    integer, intent (in) :: i, j, k, l, m, b_pin
    type(form_factor) :: pja55
    complex(ki), dimension(3) :: temp
    temp(1)=pga5(i, j, k, l, m, b_pin, 2)
    temp(2)=pga5(i, j, k, l, m, b_pin, 1)
    temp(3)=pga5(i, j, k, l, m, b_pin, 0)
    pja55=temp
  end function pja55

  function pjb55(i, j, k, b_pin)
    integer, intent (in) :: i, j, k, b_pin
    type(form_factor) :: pjb55
    complex(ki), dimension(3) :: temp
    temp(1)=pgb5(i, j, k, b_pin, 2)
    temp(2)=pgb5(i, j, k, b_pin, 1)
    temp(3)=pgb5(i, j, k, b_pin, 0)
    pjb55=temp
  end function pjb55

  function pjc55(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pjc55
    complex(ki), dimension(3) :: temp
    temp(1)=pgc5(i, b_pin, 2)
    temp(2)=pgc5(i, b_pin, 1)
    temp(3)=pgc5(i, b_pin, 0)
    pjc55=temp
  end function pjc55

  function pja60(b_pin)
    integer, intent (in) :: b_pin
    type(form_factor) :: pja60
    complex(ki), dimension(3) :: temp
    temp(1)=pga0(b_pin, 2)
    temp(2)=pga0(b_pin, 1)
    temp(3)=pga0(b_pin, 0)
    pja60=temp
  end function pja60

  function pja61(i, b_pin)
    integer, intent (in) :: i, b_pin
    type(form_factor) :: pja61
    complex(ki), dimension(3) :: temp
    temp(1)=pga1(i, b_pin, 2)
    temp(2)=pga1(i, b_pin, 1)
    temp(3)=pga1(i, b_pin, 0)
    pja61=temp
  end function pja61

  function pja62(i, j, b_pin)
    integer, intent (in) :: i, j, b_pin
    type(form_factor) :: pja62
    complex(ki), dimension(3) :: temp
    temp(1)=pga2(i, j, b_pin, 2)
    temp(2)=pga2(i, j, b_pin, 1)
    temp(3)=pga2(i, j, b_pin, 0)
    pja62=temp
  end function pja62

  function pja63(i, j, k, b_pin)
    integer, intent (in) :: i, j, k, b_pin
    type(form_factor) :: pja63
    complex(ki), dimension(3) :: temp
    temp(1)=pga3(i, j, k, b_pin, 2)
    temp(2)=pga3(i, j, k, b_pin, 1)
    temp(3)=pga3(i, j, k, b_pin, 0)
    pja63=temp
  end function pja63

  function pja64(i, j, k, l, b_pin)
    integer, intent (in) :: i, j, k, l, b_pin
    type(form_factor) :: pja64
    complex(ki), dimension(3) :: temp
    temp(1)=pga4(i, j, k, l, b_pin, 2)
    temp(2)=pga4(i, j, k, l, b_pin, 1)
    temp(3)=pga4(i, j, k, l, b_pin, 0)
    pja64=temp
  end function pja64

  function pja65(i, j, k, l, m, b_pin)
    integer, intent (in) :: i, j, k, l, m, b_pin
    type(form_factor) :: pja65
    complex(ki), dimension(3) :: temp
    temp(1)=pga5(i, j, k, l, m, b_pin, 2)
    temp(2)=pga5(i, j, k, l, m, b_pin, 1)
    temp(3)=pga5(i, j, k, l, m, b_pin, 0)
    pja65=temp
  end function pja65

  function pja66(i, j, k, l, m, n, b_pin)
    integer, intent (in) :: i, j, k, l, m, n, b_pin
    type(form_factor) :: pja66
    complex(ki), dimension(3) :: temp
    temp(1)=pga6(i, j, k, l, m, n, b_pin, 2)
    temp(2)=pga6(i, j, k, l, m, n, b_pin, 1)
    temp(3)=pga6(i, j, k, l, m, n, b_pin, 0)
    pja66=temp
  end function pja66
end module pjfry95pj
